---
title: API constructor subpage template
slug: MDN/Structures/Page_types/API_constructor_subpage_template
tags:
  - API
  - Constructor
  - Template
  - constructor subpage
  - reference page
---
<div>{{MDNSidebar}}</div>

<div class="note">
<h2 id="Remove_before_publishing">Remove before publishing</h2>

<h3 id="Title_and_slug">Title and slug</h3>

<p>An API constructor subpage should have a <em>title</em> of <em>Name</em>Of<em>TheParentInterface + "." + Name</em>Of<em>TheParentInterface</em> + "()". For example, the <a href="/en-US/docs/Web/API/Request/Request">Request()</a> constructor has a <em>title</em> of <em>Request.Request()</em>.</p>

<p>The <em>Slug</em> (the last segment at the end of the URL) should be filled in as <em>NameOfTheParentInterface</em> without the parentheses, so <code>Request()</code>'s slug is <em>Request</em>.</p>

<h3 id="Top_macros">Top macros</h3>

<p>There are five macro calls at the top of the template by default. You should update or delete them according to the advice below:</p>

<ul>
	<li>\{{draft()}} — this generates a <strong>Draft</strong> banner that indicates that the page is not yet complete, and should only be removed when the first draft of the page is completely finished. After it is ready to be published, you can remove this.</li>
	<li>\{{SeeCompatTable}} — this generates a <strong>This is an experimental technology</strong> banner that indicates the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Experimental">experimental</a>). If the technology you are documenting is not experimental, you can remove this. If it is experimental, and the technology is hidden behind a pref in Firefox, you should also fill in an entry for it in the <a href="/en-US/docs/Mozilla/Firefox/Experimental_features">Experimental features in Firefox</a> page.</li>
	<li>\{{securecontext_header}} — this generates a <strong>Secure context</strong> banner that indicates the technology is only available in a <a href="/en-US/docs/Web/Security/Secure_Contexts">secure context</a>. If it isn't, then you can remove the macro call. If it is, then you should also fill in an entry for it in the <a href="/en-US/docs/Web/Security/Secure_Contexts/features_restricted_to_secure_contexts">Features restricted to secure contexts</a> page.</li>
	<li>\{{deprecated_header}} — this generates a <strong>Deprecated</strong> banner that indicates the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Deprecated_and_obsolete">deprecated</a>. If it isn't, then you can remove the macro call.</li>
	<li>
	<div>\{{APIRef("<em>GroupDataName</em>")}} — this generates the left hand reference sidebar showing quick reference links related to the current page. For example, every page in the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> has the same sidebar, which points to the other pages in the API. To generate the correct sidebar for your API, you need to add a GroupData entry to our KumaScript GitHub repo, and include the entry's name inside the macro call in place of <em>GroupDataName</em>. See our <a href="/en-US/docs/MDN/Contribute/Structures/API_references/API_reference_sidebars">API reference sidebars</a> guide for information on how to do this.</div>
	</li>
</ul>

<h3 id="Tags">Tags</h3>

<p>In an API constructor subpage, you need to include the following tags (see the <em>Tags</em> section at the bottom of the editor UI): <strong>API</strong>, <strong>Reference</strong>, <strong>Constructor</strong>, <em>the name of the API</em> (e.g. <strong>WebVR</strong>), the name of the parent interface (e.g. <strong>IDBIndex</strong>), <strong>Experimental</strong> (if the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Experimental">experimental</a>), <strong>Secure context</strong> (if it is available in a secure context only), and <strong>Deprecated</strong> (if it is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Deprecated_and_obsolete">deprecated</a>).</p>

<p>Optionally, you can elect to include some other tags that effective represent terms people might search for when looking for information on that technology. For example on WebVR interface pages we include <strong>VR</strong> and <strong>Virtual reality</strong>.</p>

<h3 id="Browser_compatibility">Browser compatibility</h3>

<p>To fill in the browser compat data, you first need to fill in an entry for the API into our <a href="https://github.com/mdn/browser-compat-data">Browser compat data repo</a> — see our <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables#The_new_way_The_browser_compat_data_repo_and_dynamic_tables">guide on how to do this</a>.</p>

<p>Once that is done, you can show the compat data for the method with a \{{Compat()}} macro call.</p>
</div>

<div>{{draft}}{{SeeCompatTable}}{{securecontext_header}}{{deprecated_header}}{{APIRef("GroupDataName")}}</div>

<p class="summary">The summary paragraph — start by naming the constructor, and saying what it does. This should ideally be 1 or 2 short sentences. You could copy most of this from the consrtructor's summary on the corresponding API reference page.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Fill in a syntax box, according to the guidance in our <a href="/en-US/docs/MDN/Contribute/Structures/Syntax_sections">syntax sections</a> article.</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt>parameter1 {{optional_inline}}</dt>
	<dd>Include a brief description of the parameter and what it does here. Include one term and definition for each parameter. If the parameter is not optional, remove the \{{optional_inline}} macro call.</dd>
	<dt>parameter2</dt>
	<dd>etc.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Include a description of the constructor's return value, including data type and what it represents. This is normally just "An instance of the {{domxref("<em>Name</em>Of<em>TheParentInterface</em>")}} object."</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
	<dt>Exception1</dt>
	<dd>Include a list of all the exceptions that the constructor can raise, along with descriptions of how that exception is raised. Include one term and definition for each exception.</dd>
	<dt>Exception2</dt>
	<dd>etc.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Fill in a simple example that nicely shows a typical usage of the constructor, then perhaps some more complex examples (see our guide on how to add <a href="/en-US/docs/MDN/Contribute/Structures/Code_examples">code examples</a> for more information).</p>

<pre class="brush: js notranslate">my code block</pre>

<p>And/or include a list of links to useful code samples that live elsewhere:</p>

<ul>
	<li>x</li>
	<li>y</li>
	<li>z</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("NameOfSpecificationfromSpecName","#document-fragment-linking-directly-to-constructor-definition","NameOfTheConstructor")}}</td>
			<td>{{Spec2('NameOfSpecificationFromSpec2')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility_2">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("path.to.feature.NameOfTheConstructor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>Include list of</li>
	<li>other links related to</li>
	<li>this API that might</li>
	<li>be useful</li>
</ul>
